<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Practice One</title>
</head>
<body>
    <div id="container"></div>
    <script>

        function getAvatar(userId) {
            return fetch(`https://i.pravatar.cc/200?${userId}`, {
                mode: 'no-cors'
            });
        }

        function createUserCard(user) {
            const container = document.createElement("div");
            const image = document.createElement("img");
            image.src = user.imageUrl;
            const description = document.createElement("p");
            description.textContent = user.name;
            container.append(image, description);
            return container;
        }

        const users = [
            {
                userId: "1",
                name: "User One",
                country: "A",
                tags: ["Frontend"]
            },
            {
                userId: "2",
                name: "User Two",
                country: "B",
                tags: ["Frontend", "Backend", "Devops"]
            },
            {
                userId: "3",
                name: "User Three",
                country: "C",
                tags: ["Backend", "DevOps"]
            },
            {
                userId: "4",
                name: "User Four",
                country: "C",
                tags: ["DevOps"]
            },
            {
                userId: "5",
                name: "User Five",
                country: "B",
                tags: ["DevOps"]
            }
        ];
        // 1: Write a function to filter users by tags: Ex. Get All Backend Users
        function filterByTags(tag) {
            return users.filter(user => user.tags.includes(tag));
        }
        console.log(filterByTags("Frontend"));

        // 2: Function to group users by Contry ex  { "A": [...], "C": [...]}
        function groupByCountry() {
            const countryArray = {};
            users.forEach(user => {
                if (!countryArray.hasOwnProperty(user.country)) {
                    countryArray[user.country] = [];
                }
                countryArray[user.country].push(user);
            });
            return countryArray;
        }
        console.log(groupByCountry());

        // 3: A function that return a promise with image as a Blob URL
        async function getBlobURL(userId) {
            let imageSrc;
            await getAvatar(userId).then(response => {
                                return response.blob();
                            }).then(imageBlob => {
                                imageSrc = URL.createObjectURL(imageBlob);
                            });
            return imageSrc;
        }
        console.log(getBlobURL(1));

        // 4: Optional: User the createUserCard and add all the users into container div.
        function addUsers() {
            users.forEach(user => {
                user['imageUrl'] = getBlobURL(user.userId);
                const userContainer = createUserCard(user);
                document.getElementById('container').append(userContainer);
            });
        }
        addUsers();

    </script>
</body>
</html>